use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum FavoriteResource {
    Asset(super::super::super::rids::api::AssetRid),
    Run(super::super::super::run::api::RunRid),
    Notebook(super::super::super::rids::api::NotebookRid),
    NotebookTemplate(super::super::super::rids::api::TemplateRid),
    Checklist(super::super::super::rids::api::ChecklistRid),
    SavedView(super::super::super::rids::api::SavedViewRid),
    Procedure(conjure_object::ResourceIdentifier),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for FavoriteResource {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            FavoriteResource::Asset(value) => {
                map.serialize_entry(&"type", &"asset")?;
                map.serialize_entry(&"asset", value)?;
            }
            FavoriteResource::Run(value) => {
                map.serialize_entry(&"type", &"run")?;
                map.serialize_entry(&"run", value)?;
            }
            FavoriteResource::Notebook(value) => {
                map.serialize_entry(&"type", &"notebook")?;
                map.serialize_entry(&"notebook", value)?;
            }
            FavoriteResource::NotebookTemplate(value) => {
                map.serialize_entry(&"type", &"notebookTemplate")?;
                map.serialize_entry(&"notebookTemplate", value)?;
            }
            FavoriteResource::Checklist(value) => {
                map.serialize_entry(&"type", &"checklist")?;
                map.serialize_entry(&"checklist", value)?;
            }
            FavoriteResource::SavedView(value) => {
                map.serialize_entry(&"type", &"savedView")?;
                map.serialize_entry(&"savedView", value)?;
            }
            FavoriteResource::Procedure(value) => {
                map.serialize_entry(&"type", &"procedure")?;
                map.serialize_entry(&"procedure", value)?;
            }
            FavoriteResource::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for FavoriteResource {
    fn deserialize<D>(d: D) -> Result<FavoriteResource, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = FavoriteResource;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union FavoriteResource")
    }
    fn visit_map<A>(self, mut map: A) -> Result<FavoriteResource, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::Asset, Some(Variant_::Asset)) => {
                        let value = map.next_value()?;
                        FavoriteResource::Asset(value)
                    }
                    (Variant_::Run, Some(Variant_::Run)) => {
                        let value = map.next_value()?;
                        FavoriteResource::Run(value)
                    }
                    (Variant_::Notebook, Some(Variant_::Notebook)) => {
                        let value = map.next_value()?;
                        FavoriteResource::Notebook(value)
                    }
                    (Variant_::NotebookTemplate, Some(Variant_::NotebookTemplate)) => {
                        let value = map.next_value()?;
                        FavoriteResource::NotebookTemplate(value)
                    }
                    (Variant_::Checklist, Some(Variant_::Checklist)) => {
                        let value = map.next_value()?;
                        FavoriteResource::Checklist(value)
                    }
                    (Variant_::SavedView, Some(Variant_::SavedView)) => {
                        let value = map.next_value()?;
                        FavoriteResource::SavedView(value)
                    }
                    (Variant_::Procedure, Some(Variant_::Procedure)) => {
                        let value = map.next_value()?;
                        FavoriteResource::Procedure(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            FavoriteResource::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::Asset => {
                        let value = map.next_value()?;
                        FavoriteResource::Asset(value)
                    }
                    Variant_::Run => {
                        let value = map.next_value()?;
                        FavoriteResource::Run(value)
                    }
                    Variant_::Notebook => {
                        let value = map.next_value()?;
                        FavoriteResource::Notebook(value)
                    }
                    Variant_::NotebookTemplate => {
                        let value = map.next_value()?;
                        FavoriteResource::NotebookTemplate(value)
                    }
                    Variant_::Checklist => {
                        let value = map.next_value()?;
                        FavoriteResource::Checklist(value)
                    }
                    Variant_::SavedView => {
                        let value = map.next_value()?;
                        FavoriteResource::SavedView(value)
                    }
                    Variant_::Procedure => {
                        let value = map.next_value()?;
                        FavoriteResource::Procedure(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        FavoriteResource::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    Asset,
    Run,
    Notebook,
    NotebookTemplate,
    Checklist,
    SavedView,
    Procedure,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::Asset => "asset",
            Variant_::Run => "run",
            Variant_::Notebook => "notebook",
            Variant_::NotebookTemplate => "notebookTemplate",
            Variant_::Checklist => "checklist",
            Variant_::SavedView => "savedView",
            Variant_::Procedure => "procedure",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "asset" => Variant_::Asset,
            "run" => Variant_::Run,
            "notebook" => Variant_::Notebook,
            "notebookTemplate" => Variant_::NotebookTemplate,
            "checklist" => Variant_::Checklist,
            "savedView" => Variant_::SavedView,
            "procedure" => Variant_::Procedure,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the FavoriteResource union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
